#pragma once
#include <QObject>

#include "QObjectPtr.h"
#include "minecraft/auth/AuthStep.h"

class Yggdrasil;

class CustomStep : public AuthStep {
    Q_OBJECT

public:
    explicit CustomStep(AccountData *data, QString password);
    virtual ~CustomStep() noexcept;

    void perform() override;
    void rehydrate() override;

    QString describe() override;

    void setUrl(QString url);

private slots:
    void onAuthSucceeded();
    void onAuthFailed();

private:
    Yggdrasil *m_yggdrasil = nullptr;
    QString m_password;
    QString m_url;
};
